require 'hashie'
require 'faraday'
require 'faraday-cookie_jar'
require 'faraday_middleware'

require File.expand_path('../idonethis/version', __FILE__)
require File.expand_path('../idonethis/error', __FILE__)
require File.expand_path('../idonethis/configuration', __FILE__)
require File.expand_path('../idonethis/client', __FILE__)
require File.expand_path('../idonethis/middleware', __FILE__)
require File.expand_path('../idonethis/models/done', __FILE__)

module IDoneThis
  extend Configuration

  def self.client(options={})
    IDoneThis::Client.new(options)
  end

  def self.method_missing(method, *args, &block)
    return super unless client.respond_to?(method)
    client.send(method, *args, &block)
  end
  
  def self.respond_to?(method)
    return client.respond_to?(method) || super
  end

end
