module IDoneThis
  module Configuration
    VALID_OPTIONS_KEYS = [
      :username,
      :password,
      :team
    ].freeze

    DEFAULT_USERNAME = nil
    DEFAULT_PASSWORD = nil
    DEFAULT_TEAM     = nil

    attr_accessor *VALID_OPTIONS_KEYS
    
    def self.extended(base)
      base.reset
    end

    def configure
      yield self
    end

    def options
      VALID_OPTIONS_KEYS.inject({}) do |option, key|
        option.merge!(key => send(key))
      end
    end

    def reset
      self.username = DEFAULT_USERNAME
      self.password = DEFAULT_PASSWORD
      self.team     = DEFAULT_TEAM
    end
  end
end
